<?php
namespace Teknisa\SM\Controller;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\SM\Controller\SMCrud;
use Teknisa\SM\Service\Sm00048000ImpostoService;

class Sm00048000ImpostoController extends SMCrud {
    protected $impostoservice;
    public function  __construct($crudService, $environment, Sm00048000ImpostoService $impostoservice){
        parent::__construct($crudService, $environment);
        $this->impostoservice = $impostoservice;
    }
    /**
     * Deleta alguns servicos do imposto ou o imposto inteiro
    **/
    public function deleteImposto(Request\Row $request, Response $response){
        try{
            $row = $request->getRow();
            $cdimposto     = $row["CDIMPOSTO"];
            $nrimpostoserv = $row["NRIMPOSTOSERV"];
            $nrorg = $this->environment->getNrorg();
            $this->impostoservice->deleteImposto($cdimposto, $nrorg, $nrimpostoserv);
        } catch(\Exception $e){
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));        
        }
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
    **/
    public function salvarEdicaoImposto(Request\Row $request, Response $response){
        try{
            $row   = $request->getRow();
            $nrorg = $this->environment->getNrorg();
            $cdimposto     = $row["CDIMPOSTO"];
            $vrprecimposto = $row["VRPRECIMPOSTO"];
            $this->impostoservice->salvarEdicaoImposto($cdimposto, $nrorg, $vrprecimposto);
        } catch(\Exception $e){
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));        
        }
    }
}