<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctGerarParcelasApuracao {
    
    const NOME = "FCT_GERAR_PARCELAS_APURACAO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrseqorcamento
     * @param integer $nrmedicaofatura
     * @param integer $nrorg
     * @param string  $cdoperador
     */
    public function executar($nrseqcontrato, $nrmedicaofatura, $nrorg, $cdoperador) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQCONTRATO",     Param::PARAM_INPUT,  $nrseqcontrato,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRMEDICAOFATURA",   Param::PARAM_INPUT,  $nrmedicaofatura,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRORG",             Param::PARAM_INPUT,  $nrorg,             Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_CDOPERADOR",        Param::PARAM_INPUT,  $cdoperador,        Param::PARAM_TYPE_STR));
        
        $resultado = $procedure->execute();
    }
    
}

?>