IF EXISTS(SELECT NAME
            FROM SYSOBJECTS
           WHERE NAME = 'GRAVA_LANC_CTB' AND TYPE = 'P')
   DROP PROCEDURE GRAVA_LANC_CTB
GO


CREATE PROCEDURE GRAVA_LANC_CTB (
  @P_NRLANCCONT   VARCHAR(12),
  @P_CDEMPRESA    VARCHAR(02))
AS
   DECLARE @V_CONTCOME   VARCHAR(01);
   DECLARE @V_CREDDEB    VARCHAR(01);
   DECLARE @V_CONTRAT    VARCHAR(01);
   DECLARE @V_COUNT      INT;

   /* VARIVEIS DO CURSOR LANCCONT */
   DECLARE @LANCCONT_CDEMPRESA       VARCHAR(02);
   DECLARE @LANCCONT_NRLANCCTBTEMP   VARCHAR(12);
   DECLARE @LANCCONT_DTLANCCTBTEMP   DATE;
   DECLARE @LANCCONT_NRSEQCTBTEMP    VARCHAR(05);
   DECLARE @LANCCONT_CDCONTCTBL      VARCHAR(20);
   DECLARE @LANCCONT_CDHISTPADR      VARCHAR(04);
   DECLARE @LANCCONT_DSHISTCTB       VARCHAR(200);
   DECLARE @LANCCONT_VRLANCCTBTEMP   DOUBLE PRECISION;
   DECLARE @LANCCONT_IDLANCCTBCOME   VARCHAR(01);
   DECLARE @LANCCONT_CDLANCCTBCOME   VARCHAR(21);
   DECLARE @LANCCONT_CDDOCUTEMP      VARCHAR(20);
   DECLARE @LANCCONT_IDSISTEMA       VARCHAR(03);

   /* VARIVEIS DO CURSOR RAT */
   DECLARE @RAT_CDFILIAL   VARCHAR (04);
   DECLARE @RAT_CDCENTCUST VARCHAR (04);
   DECLARE @RAT_DTCOMPCTBTEMP DATE;
   DECLARE @RAT_VRLANCCUST    DOUBLE PRECISION;
   DECLARE @RAT_NRSEQCTBTEMP  VARCHAR(05);
   DECLARE @RAT_NRLANCCTBTEMP VARCHAR(12);
   DECLARE @RAT_CDEMPRESA     VARCHAR(02);

   DECLARE @V_IDNULL VARCHAR(1);

BEGIN
   SELECT @V_CONTRAT = IDCONTGERE
     FROM CONTOPECTBL
    WHERE CDEMPRESA = @P_CDEMPRESA;

   SELECT @V_COUNT = COUNT(*)
     FROM ERROCTBTEMP
    WHERE CDEMPRESA     = @P_CDEMPRESA
      AND NRLANCCTBTEMP = @P_NRLANCCONT;

   IF @V_COUNT = 0 BEGIN
      DECLARE LANCCONT CURSOR FOR
         SELECT L.CDEMPRESA,  L.NRLANCCTBTEMP, L.DTLANCCTBTEMP, L.NRSEQCTBTEMP, L.CDCONTCTBL,
                L.CDHISTPADR, L.DSHISTCTB, L.VRLANCCTBTEMP, CASE L.IDLANCCTBCOME WHEN 'N' THEN NULL ELSE IDLANCCTBCOME END IDLANCCTBCOME,
                L.CDLANCCTBCOME, L.CDDOCUTEMP CDDOCUCONT, L.IDSISTEMA
           FROM LANCCTBTEMP L, CONTCTBL C, EMPRESA E
          WHERE L.CDCONTCTBL  = C.CDCONTCTBL
            AND L.CDEMPRESA   = E.CDEMPRESA
            AND L.CDEMPRESA   = @P_CDEMPRESA
            AND NRLANCCTBTEMP = @P_NRLANCCONT
          ORDER BY NRSEQCTBTEMP;
      OPEN LANCCONT;
      FETCH NEXT FROM LANCCONT INTO @LANCCONT_CDEMPRESA,  @LANCCONT_NRLANCCTBTEMP, @LANCCONT_DTLANCCTBTEMP, @LANCCONT_NRSEQCTBTEMP,
                                    @LANCCONT_CDCONTCTBL, @LANCCONT_CDHISTPADR, @LANCCONT_DSHISTCTB, @LANCCONT_VRLANCCTBTEMP, @LANCCONT_IDLANCCTBCOME,
                                    @LANCCONT_CDLANCCTBCOME, @LANCCONT_CDDOCUTEMP, @LANCCONT_IDSISTEMA;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @LANCCONT_VRLANCCTBTEMP > 0 BEGIN
            SET @V_CREDDEB = 'C';
         END
         ELSE BEGIN
            SET @V_CREDDEB = 'D';
         END;

         IF @LANCCONT_IDLANCCTBCOME = '' BEGIN
            SET @V_IDNULL = NULL;
         END
         ELSE BEGIN
            SET @V_IDNULL = @LANCCONT_IDLANCCTBCOME;
         END;

         INSERT INTO LANCCONT
            (CDEMPRESA, NRLANCCONT, NRSEQLANC, DTLANCCONT, CDCONTCTBL,
             CDHISTPADR, DSHISTLANC, IDTIPOLANC, VRLANCAMENT,
             IDLANCSALDO, IDLANCINTE, DTULTATULAN, IDLANCCOME, CDCONTCOME, CDDOCUCONT, IDSISTEMA)
         VALUES
            (@LANCCONT_CDEMPRESA, @LANCCONT_NRLANCCTBTEMP, @LANCCONT_NRSEQCTBTEMP, @LANCCONT_DTLANCCTBTEMP, @LANCCONT_CDCONTCTBL,
             @LANCCONT_CDHISTPADR, @LANCCONT_DSHISTCTB, @V_CREDDEB, @LANCCONT_VRLANCCTBTEMP,
             'N', 'I', GETDATE(), @V_IDNULL, @LANCCONT_CDLANCCTBCOME, @LANCCONT_CDDOCUTEMP, @LANCCONT_IDSISTEMA);

         IF @V_CONTRAT = 'S' BEGIN
            DECLARE RAT CURSOR FOR
               SELECT R.CDFILIAL,R.CDCENTCUST, R.DTCOMPCTBTEMP DTCOMPCTBTEMP,
                      R.VRRATECTBTEMP VRLANCCUST, R.NRSEQCTBTEMP, R.NRLANCCTBTEMP, R.CDEMPRESA
                 FROM RATECTBTEMP R, FILIAL F, CENTCUST C, LANCCTBTEMP L
                WHERE R.NRLANCCTBTEMP = @LANCCONT_NRLANCCTBTEMP
                  AND R.CDEMPRESA     = @LANCCONT_CDEMPRESA
                  AND R.CDFILIAL      = F.CDFILIAL
                  AND R.CDCENTCUST    = C.CDCENTCUST
                  AND R.NRLANCCTBTEMP = L.NRLANCCTBTEMP
                  AND R.NRSEQCTBTEMP  = L.NRSEQCTBTEMP
                  AND R.NRSEQCTBTEMP = @LANCCONT_NRSEQCTBTEMP
                ORDER BY R.CDFILIAL, R.CDCENTCUST;
            OPEN RAT;
            FETCH NEXT FROM RAT INTO @RAT_CDFILIAL, @RAT_CDCENTCUST, @RAT_DTCOMPCTBTEMP, @RAT_VRLANCCUST,
                                     @RAT_NRSEQCTBTEMP, @RAT_NRLANCCTBTEMP, @RAT_CDEMPRESA;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               INSERT INTO LANCCCUSTO
                  (CDEMPRESA, NRLANCCONT, NRSEQLANC, CDFILIAL, CDCENTCUST, VRLANCCUST, DTCOMPCUSTO, CDCONTCTBL)
               VALUES
                  (@RAT_CDEMPRESA, @RAT_NRLANCCTBTEMP, @RAT_NRSEQCTBTEMP, @RAT_CDFILIAL, @RAT_CDCENTCUST, @RAT_VRLANCCUST, @RAT_DTCOMPCTBTEMP, @LANCCONT_CDCONTCTBL);

               FETCH NEXT FROM RAT INTO @RAT_CDFILIAL, @RAT_CDCENTCUST, @RAT_DTCOMPCTBTEMP, @RAT_VRLANCCUST,
                                     @RAT_NRSEQCTBTEMP, @RAT_NRLANCCTBTEMP, @RAT_CDEMPRESA;
            END;
            CLOSE RAT;
            DEALLOCATE RAT;
         END;
         FETCH NEXT FROM LANCCONT INTO @LANCCONT_CDEMPRESA,  @LANCCONT_NRLANCCTBTEMP, @LANCCONT_DTLANCCTBTEMP, @LANCCONT_NRSEQCTBTEMP,
                                       @LANCCONT_CDCONTCTBL, @LANCCONT_CDHISTPADR, @LANCCONT_DSHISTCTB, @LANCCONT_VRLANCCTBTEMP, @LANCCONT_IDLANCCTBCOME,
                                       @LANCCONT_CDLANCCTBCOME, @LANCCONT_CDDOCUTEMP, @LANCCONT_IDSISTEMA;
      END;
      CLOSE LANCCONT;
      DEALLOCATE LANCCONT;

      DELETE FROM LANCCTBTEMP
       WHERE NRLANCCTBTEMP = @P_NRLANCCONT
         AND CDEMPRESA     = @P_CDEMPRESA;

      DELETE FROM RATECTBTEMP
       WHERE NRLANCCTBTEMP = @P_NRLANCCONT
         AND CDEMPRESA     = @P_CDEMPRESA;
   END;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'GRAVA_LANC_CTB','5.50.000';
GO

